#include <stdio.h>

class X {
public:
  int a;

  X( int i ) : a( i )
  {
    printf( "Constructing %d\n", i );
  }
  X( const X& x) : a( x.a + 1 )
  {
    printf( "Copy constructor for %d\n", x.a );
  }
  ~X() { printf( "destroying %d\n", a ); }
  X operator+( const X& x ) const { return( a + x.a ); }
};

X Test( int n )
{
  printf( "\nTesting %d\n", n );
  switch ( n ) {
    case 100: return( X( 100 ) + X( 2 ) );
    case 101: return( X( 101 ) + X( 3 ) );
  }
  return( 0 );
}

void main()
{
  X a( 1 );
  X b = a;

  Test( 100 );
  printf( "\nDone with 100\n" );
  Test( 101 );
  printf( "\nDone with 101\n" );
  Test( 102 );
  printf( "\nDone with 102\n" );
}


